package org.archiviststoolkit.plugin;

import org.java.plugin.Plugin;
import org.archiviststoolkit.mydomain.DomainObject;
import org.archiviststoolkit.swing.InfiniteProgressPanel;
import org.archiviststoolkit.ApplicationFrame;
import org.archiviststoolkit.editor.ArchDescriptionFields;

import javax.swing.*;
import java.awt.*;
import java.util.HashMap;

/**
 * Archivists' Toolkit(TM) Copyright  2005-2007 Regents of the University of California, New York University, & Five Colleges, Inc.
 * All rights reserved.
 * <p/>
 * This software is free. You can redistribute it and / or modify it under the terms of the Educational Community License (ECL)
 * version 1.0 (http://www.opensource.org/licenses/ecl1.php)
 * <p/>
 * This software is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the ECL license for more details about permissions and limitations.
 * <p/>
 * <p/>
 * Archivists' Toolkit(TM)
 * http://www.archiviststoolkit.org
 * info@archiviststoolkit.org
 * <p/>
 * Created by IntelliJ IDEA.
 *
 * This is a very simple plugin that creates a csv file containing information
 * from digital objects. The primary use of this is to create a shoot
 * list containing the title the persistantID so that the persons
 * doing the imaging can have something to work with.
 *
 * It can eiter be ran as a plugin for the AT or a standalone application
 *
 * @author: Nathan Stevens
 * Date: Mar 6, 2009
 * Time: 12:55:04 PM
 */
public class ShootListPlugin extends Plugin implements ATPlugin {
    protected ApplicationFrame mainFrame;
    private ShootListPluginFrame pluginFrame;

    /**
     * Get the category this plugin belongs to
     *
     * @return The category of this plugin
     */
    public String getCategory() {
        return ATPlugin.DEFAULT_CATEGORY;
    }

    /**
     * Get the name of the plugin
     *
     * @return The name of this plugin
     */
    public String getName() {
        return "ShootList v1.0";
    }

    // Method to set the AT main frame
    public void setApplicationFrame(ApplicationFrame mainFrame) {
        this.mainFrame = mainFrame;
    }

    // Method that display the actually plugin frame
    public void showPlugin() {
        pluginFrame = new ShootListPluginFrame();
        pluginFrame.setApplicationFrame(mainFrame);
        pluginFrame.pack();
        pluginFrame.setVisible(true);
    }

    // method to display a plugin that needs a parent frame
    public void showPlugin(Frame owner) { }

    // method to display a plugin that needs a parent dialog
    public void showPlugin(Dialog owner) { }

    // Method to return any panels for embedded plugins
    public HashMap getEmbeddedPanels() {
        return null;
    }

    // Method to set the editor field. This is not used here
    public void setEditorField(ArchDescriptionFields editorField) {  }

    /**
     * Method to set the domain object for this plugin
     */
    public void setModel(DomainObject domainObject, InfiniteProgressPanel monitor) { }

    /**
     * Method to get the table from which the record was selected
     * @param callingTable The table containing the record
     */
    public void setCallingTable(JTable callingTable) { }

    /**
     * Method to set the selected row of the calling table
     * @param selectedRow
     */
    public void setSelectedRow(int selectedRow) { }

    /**
     * Method to set the current record number along with the total number of records
     * @param recordNumber The current record number
     * @param totalRecords The total number of records
     */
    public void setRecordPositionText(int recordNumber, int totalRecords) { }

    // Method to do a specific task in the plugin
    public void doTask(String task) { }

    // Method to get the list of specific task the plugin can perform
    public String[] getTaskList() {
        return null;
    }

    // Method to return the editor type for this plugin
    public String getEditorType() {
        return "";
    }

    // code that is executed when plugin starts. not used here
    protected void doStart()  { }

    // code that is executed after plugin stops. not used here
    protected void doStop()  { }

    // main method for running this plugin as a stand alone application
    public static void main(String[] args) {
        ShootListPlugin shootListPlugin = new ShootListPlugin();
        shootListPlugin.showPlugin();
    }
}
